import cv2 as cv
import numpy as np
from matplotlib import pyplot as plt 
import time
import support_uns as support
import random

np.set_printoptions(suppress=True) # 完整显示
t0 = time.time()
# 初始化获得轮廓、点数
src=cv.imread("../image/text11.png") 
contourPoints, contournum, src = support.img_init(src)  
# src=cv.imread("./image/text11.png")    
# contourPoints, contournum, src  = support.get_contours_XLD(src)  
t1 = time.time()
for Points in contourPoints:
    t2 = time.time()
    Points = Points.reshape(-1,2)
    pointnum = len(Points)
    AnglesGroup, Angles_Group = support.get_anglesGroup(Points,int(pointnum/500))
    print("len(AnglesGroup): ",len(AnglesGroup))
    #集合Angle、Angle_前后互补，获得特征点
    roi_point, Point2 = support.get_roi( AnglesGroup, Angles_Group)
    print("roi_point.shape",roi_point.shape)
    # 点簇
    roi_point, roi_point_1 = support.get_pointsgroups(pointnum, roi_point)
    roi_point, roi_point_1 = support.adaptive_stepsize(Points,roi_point,roi_point_1)
    t3 = time.time()
    roi_point_2 = support.get_parts_grade(Points, pointnum, roi_point, 3)
    print("roi_point_2.shape: ",roi_point_2.shape)
    t4 = time.time()
    roi_point_3 = support.get_preciseROI(pointnum, roi_point_2)
    t5 = time.time()
    roi_point_3 = support.get_roi_points(roi_point_3, pointnum)
    out = support.out_results(Points, pointnum, roi_point_3)
    t6 = time.time()

    print("init time",t1-t0)
    print("ROI time",t3-t2)
    print("fit time",t4-t3)
    print("NMS time",t5-t4)
    print("param time",t6-t5)
    print("part time",t6-t2)
    # a=2
    # b=3
    # for p in roi_point_3:
    #     color = (random.randint(10,255), random.randint(50,255), random.randint(30,255))
    #     # for p in ps:
    #     j = Points[int(p)]
    #     src[int(j[1]-a):int(j[1]+b),int(j[0]-a):int(j[0]+b)]=color
    # fig1, ax1 = plt.subplots()
    # ax1.imshow(src)#,cmap='gray'
    

print("all time",t6-t0)
plt.show()